// sodo - liho sortiranje enostavno paraleliziramo

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "omp.h"

#define SIZE 50000

int main(void)
{
	int *a;
	int i, j, tmp;
	double dt;

	a = (int *)malloc(sizeof(int)*SIZE);
	srand((unsigned int)time(NULL));
	for(i=0; i<SIZE; i++)
		a[i] = rand();

	dt = omp_get_wtime();

	for(i=0; i<SIZE-1; i++)
		if(i%2==0)
			#pragma omp parallel for private(j, tmp)
			for(j=0; j<SIZE-1; j+=2)
			{
				if(a[j] > a[j+1])
				{
					tmp = a[j];
					a[j] = a[j+1];
					a[j+1] = tmp;
				}
			}
		else
			#pragma omp parallel for private(j, tmp)
			for(j=1; j<SIZE-1; j+=2)
			{
				if(a[j] > a[j+1])
				{
					tmp = a[j];
					a[j] = a[j+1];
					a[j+1] = tmp;
				}
			}

	dt = omp_get_wtime()-dt;


	for(i=1; i<SIZE; i++)
		if(a[i-1] > a[i])
			printf("napaka: %d\n", i);

	printf("\nCas: %lf\n", dt);

	free(a);
}
